<template>
  <div>
    <header class="text-center">
      <Logo />
      <h1>Medcall</h1>
    </header>

    <section class="container text-center">
      <!-- <NuxtLink class="button--grey" rel="noopener noreferrer" to="/login">Iniciar</NuxtLink> -->

      <a rel="noopener noreferrer" class="button--grey" @click="loginWithGoogle">Entrar</a>

      <!-- <p class="hasAccount mt-3">
        Não possui uma conta?
        <NuxtLink rel="noopener noreferrer" to="/register">Registrar</NuxtLink>
      </p> -->
    </section>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'


export default Vue.extend({
  methods: {
    // async writeToFirestore() {
    //   const messageRef = this.$fire.firestore
    //     .collection('message')
    //     .doc('message')
    //   try {
    //     await messageRef.set({
    //       message: 'Nuxt-Fire with Firestore rocks!',
    //     })
    //   } catch (e) {
    //     alert(e)
    //     return
    //   }
    //   alert('Success.')
    // },

    // async readFromFirestore() {
    //   console.log('a1');
    //   const messageRef = this.$fire.firestore
    //     .collection('teste')
    //     .doc('batata')
    //   try {
    //     const snapshot = await messageRef.get()
    //     const doc = snapshot.data()
    //     if (!doc) {
    //       alert('Document does not exist.')
    //       return
    //     }
    //     alert(doc.nome)
    //   } catch (e) {
    //     alert(e)
    //   }
    // },

    async loginWithGoogle() {
      try {
        const provider = new this.$fireModule.auth.GoogleAuthProvider();
        const result = await this.$fire.auth.signInWithPopup(provider);

        if (result.additionalUserInfo?.isNewUser) {
          const newUser = this.$fire.firestore
            .collection('Users')
            .doc(result.user?.uid)
          try {
            await newUser.set({
              uid: result.user?.uid,
              displayName: result.user?.displayName,
              email: result.user?.email,
              phoneNumber: result.user?.phoneNumber,
              photoURL: result.user?.photoURL,
              gender: null,
              age: null,
            })
          } catch (e) {
            alert(e)
            return
          }
        }
      } catch (error) {
        // TODO
        console.error('login error', error);
      }
    },
  },
})
</script>

<style>
p.hasAccount {
  font-size: 13px;
  color: rgba(104, 178, 160, 55);
  margin-top: 1rem;
}

a {
  color: #205072;
}
</style>
